import { ResourceAttributes } from '@opentelemetry/resources/build/src/types';
import { WorkersSDK } from '@highlight-run/opentelemetry-sdk-workers';

declare const HIGHLIGHT_PROJECT_ENV = "HIGHLIGHT_PROJECT_ID";
interface HighlightEnv {
    [HIGHLIGHT_PROJECT_ENV]: string;
    HIGHLIGHT_OTLP_ENDPOINT?: string;
}
type Metric = {
    secureSessionId: string;
    name: string;
    value: number;
    requestId: string;
    tags?: {
        name: string;
        value: string;
    }[];
};
interface HighlightInterface {
    init: (request: Request, env: HighlightEnv, ctx: ExecutionContext, service?: string) => WorkersSDK;
    isInitialized: () => boolean;
    consumeError: (error: Error) => void;
    sendResponse: (response: Response) => void;
    setAttributes: (attributes: ResourceAttributes) => void;
    recordMetric: (metric: Metric) => void;
}
declare const H: HighlightInterface;
declare function extractRequestMetadata(request: Request): {
    secureSessionId: string;
    requestId: string;
};

export { H, HighlightEnv, extractRequestMetadata };
